import { Component, ViewEncapsulation, ChangeDetectionStrategy, ChangeDetectorRef, ViewChild, Input, Injectable, InjectionToken, Inject, Directive, ElementRef, Renderer, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ContextMenuService, ContextMenuModule } from 'ngx-contextmenu';
import { distinctUntilChanged, map, filter, withLatestFrom, mergeMap, catchError, switchMap, take } from 'rxjs/operators';
import * as _isEqual from 'lodash.isequal';
import { createFeatureSelector, createSelector, select, Store, StoreModule } from '@ngrx/store';
import { Subscription, combineLatest, empty, Subject, BehaviorSubject, merge, of } from 'rxjs';
import { Actions, ofType, Effect, EffectsModule } from '@ngrx/effects';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { DndModule, DraggableComponent } from 'ng2-dnd';
import { __decorate, __metadata } from 'tslib';
import { HttpParams, HttpClient, HttpClientModule } from '@angular/common/http';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const TreeActionTypes = {
    TREE_SAVE_NODE: 'TREE_SAVE_NODE',
    TREE_SAVE_NODE_SUCCESS: 'TREE_SAVE_NODE_SUCCESS',
    TREE_SAVE_NODE_ERROR: 'TREE_SAVE_NODE_ERROR',
    TREE_DELETE_NODE: 'TREE_DELETE_NODE',
    TREE_DELETE_NODE_SUCCESS: 'TREE_DELETE_NODE_SUCCESS',
    TREE_DELETE_NODE_ERROR: 'TREE_DELETE_NODE_ERROR',
    TREE_EDIT_NODE_START: 'TREE_EDIT_NODE_START',
    TREE_COLLAPSE_NODE: 'TREE_COLLAPSE_NODE',
    TREE_EXPAND_NODE: 'TREE_EXPAND_NODE',
    TREE_INSERT_NODE: 'TREE_INSERT_NODE',
    TREE_LOAD: 'TREE_LOAD',
    TREE_LOAD_PATH: 'TREE_LOAD_PATH',
    TREE_LOAD_SUCCESS: 'TREE_LOAD_SUCCESS',
    TREE_LOAD_ERROR: 'TREE_LOAD_ERROR',
    TREE_MARK_AS_FULLY_LOADED: 'TREE_MARK_AS_FULLY_LOADED',
    TREE_MOVE_NODE: 'TREE_MOVE_NODE',
    TREE_MOVE_NODE_SUCCESS: 'TREE_MOVE_NODE_SUCCESS',
    TREE_MOVE_NODE_ERROR: 'TREE_MOVE_NODE_ERROR',
    TREE_REGISTER: 'TREE_REGISTER',
    TREE_SELECT_NODE: 'TREE_SELECT_NODE',
    TREE_SET_ALL_NODES: 'TREE_SET_ALL_NODES',
    TREE_SET_CONFIGURATION: 'TREE_SET_CONFIGURATION',
};
class TreeCollapseNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_COLLAPSE_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeCollapseNodeAction.prototype.type;
    /** @type {?} */
    TreeCollapseNodeAction.prototype.payload;
}
class TreeDeleteNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_DELETE_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeDeleteNodeAction.prototype.type;
    /** @type {?} */
    TreeDeleteNodeAction.prototype.payload;
}
class TreeDeleteNodeErrorAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_DELETE_NODE_ERROR;
    }
}
if (false) {
    /** @type {?} */
    TreeDeleteNodeErrorAction.prototype.type;
    /** @type {?} */
    TreeDeleteNodeErrorAction.prototype.payload;
}
class TreeDeleteNodeSuccessAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_DELETE_NODE_SUCCESS;
    }
}
if (false) {
    /** @type {?} */
    TreeDeleteNodeSuccessAction.prototype.type;
    /** @type {?} */
    TreeDeleteNodeSuccessAction.prototype.payload;
}
class TreeEditNodeStartAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_EDIT_NODE_START;
    }
}
if (false) {
    /** @type {?} */
    TreeEditNodeStartAction.prototype.type;
    /** @type {?} */
    TreeEditNodeStartAction.prototype.payload;
}
class TreeExpandNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_EXPAND_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeExpandNodeAction.prototype.type;
    /** @type {?} */
    TreeExpandNodeAction.prototype.payload;
}
class TreeInsertNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_INSERT_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeInsertNodeAction.prototype.type;
    /** @type {?} */
    TreeInsertNodeAction.prototype.payload;
}
class TreeLoadNodesAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_LOAD;
    }
}
if (false) {
    /** @type {?} */
    TreeLoadNodesAction.prototype.type;
    /** @type {?} */
    TreeLoadNodesAction.prototype.payload;
}
class TreeLoadNodesErrorAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_LOAD_ERROR;
    }
}
if (false) {
    /** @type {?} */
    TreeLoadNodesErrorAction.prototype.type;
    /** @type {?} */
    TreeLoadNodesErrorAction.prototype.payload;
}
class TreeLoadNodesSuccessAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_LOAD_SUCCESS;
    }
}
if (false) {
    /** @type {?} */
    TreeLoadNodesSuccessAction.prototype.type;
    /** @type {?} */
    TreeLoadNodesSuccessAction.prototype.payload;
}
class TreeLoadPathAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_LOAD_PATH;
    }
}
if (false) {
    /** @type {?} */
    TreeLoadPathAction.prototype.type;
    /** @type {?} */
    TreeLoadPathAction.prototype.payload;
}
class TreeMarkAsFullyLoadedAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_MARK_AS_FULLY_LOADED;
    }
}
if (false) {
    /** @type {?} */
    TreeMarkAsFullyLoadedAction.prototype.type;
    /** @type {?} */
    TreeMarkAsFullyLoadedAction.prototype.payload;
}
class TreeMoveNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_MOVE_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeMoveNodeAction.prototype.type;
    /** @type {?} */
    TreeMoveNodeAction.prototype.payload;
}
class TreeMoveNodeErrorAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_MOVE_NODE_ERROR;
    }
}
if (false) {
    /** @type {?} */
    TreeMoveNodeErrorAction.prototype.type;
    /** @type {?} */
    TreeMoveNodeErrorAction.prototype.payload;
}
class TreeMoveNodeSuccessAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_MOVE_NODE_SUCCESS;
    }
}
if (false) {
    /** @type {?} */
    TreeMoveNodeSuccessAction.prototype.type;
    /** @type {?} */
    TreeMoveNodeSuccessAction.prototype.payload;
}
class TreeRegisterAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_REGISTER;
    }
}
if (false) {
    /** @type {?} */
    TreeRegisterAction.prototype.type;
    /** @type {?} */
    TreeRegisterAction.prototype.payload;
}
class TreeSaveNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_SAVE_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeSaveNodeAction.prototype.type;
    /** @type {?} */
    TreeSaveNodeAction.prototype.payload;
}
class TreeSaveNodeErrorAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_SAVE_NODE_ERROR;
    }
}
if (false) {
    /** @type {?} */
    TreeSaveNodeErrorAction.prototype.type;
    /** @type {?} */
    TreeSaveNodeErrorAction.prototype.payload;
}
class TreeSaveNodeSuccessAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_SAVE_NODE_SUCCESS;
    }
}
if (false) {
    /** @type {?} */
    TreeSaveNodeSuccessAction.prototype.type;
    /** @type {?} */
    TreeSaveNodeSuccessAction.prototype.payload;
}
class TreeSelectNodeAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_SELECT_NODE;
    }
}
if (false) {
    /** @type {?} */
    TreeSelectNodeAction.prototype.type;
    /** @type {?} */
    TreeSelectNodeAction.prototype.payload;
}
class TreeSetAllNodesAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_SET_ALL_NODES;
    }
}
if (false) {
    /** @type {?} */
    TreeSetAllNodesAction.prototype.type;
    /** @type {?} */
    TreeSetAllNodesAction.prototype.payload;
}
class TreeSetConfigurationAction {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = TreeActionTypes.TREE_SET_CONFIGURATION;
    }
}
if (false) {
    /** @type {?} */
    TreeSetConfigurationAction.prototype.type;
    /** @type {?} */
    TreeSetConfigurationAction.prototype.payload;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const NEW_NODE_ID = 'ri-new-node-id';
/** @type {?} */
const emptyTreeData = {
    nodes: {
        entities: {},
        previouslySelected: null,
        selected: null,
        rootNodes: [],
        expanded: [],
    },
    configuration: {
        isFullyLoaded: false
    }
};
/**
 * @param {?} state
 * @param {?=} treeId
 * @return {?}
 */
function copyState(state, treeId = null) {
    /** @type {?} */
    const newState = Object.assign({}, state);
    if (treeId) {
        newState[treeId] = {
            nodes: {
                entities: Object.assign({}, state[treeId].nodes.entities),
                previouslySelected: state[treeId].nodes.previouslySelected,
                selected: state[treeId].nodes.selected,
                rootNodes: [...state[treeId].nodes.rootNodes],
                expanded: [...state[treeId].nodes.expanded],
            },
            configuration: Object.assign({}, state[treeId].configuration)
        };
    }
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function removeNode(state, action) {
    /** @type {?} */
    const newState = copyState(state, action.payload.treeId);
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const treeState = newState[treeId];
    /** @type {?} */
    const node = action.payload.node;
    /** @type {?} */
    const parentId = node.parentId;
    delete treeState.nodes.entities[node.id];
    if (parentId) {
        /** @type {?} */
        const parent = Object.assign({}, treeState.nodes.entities[parentId]);
        if (parent.children) {
            parent.children = parent.children.filter((/**
             * @param {?} id
             * @return {?}
             */
            (id) => id !== node.id));
        }
        treeState.nodes.entities[parentId] = parent;
    }
    else {
        treeState.nodes.rootNodes = treeState.nodes.rootNodes.filter((/**
         * @param {?} id
         * @return {?}
         */
        (id) => id !== node.id));
    }
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function loadNodes(state, action) {
    /** @type {?} */
    const newState = copyState(state, action.payload.treeId);
    /** @type {?} */
    let parent = null;
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const parentId = action.payload.id;
    if (parentId) {
        parent = newState[treeId].nodes.entities[parentId];
        parent.children = [];
    }
    else {
        newState[treeId].nodes.entities = {};
    }
    action.payload.nodes.forEach((/**
     * @param {?} nodeData
     * @return {?}
     */
    (nodeData) => {
        nodeData.treeId = treeId;
        if (parent) {
            parent.children.push(nodeData.id);
            nodeData.parents = [...parent.parents, ...[parent.id]];
        }
        else {
            nodeData.parents = [];
        }
        newState[treeId].nodes.entities[nodeData.id] = nodeData;
        if (!parentId) {
            newState[treeId].nodes.rootNodes.push(nodeData.id);
        }
    }));
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function expandNode(state, action) {
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const newState = copyState(state, treeId);
    /** @type {?} */
    const nodeId = action.payload.id;
    // newState[treeId].nodes.entities[nodeId] = Object.assign({}, newState[treeId].nodes.entities[nodeId], {isExpanded: true});
    newState[treeId].nodes.expanded = [...newState[treeId].nodes.expanded, nodeId];
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function collapseNode(state, action) {
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const newState = copyState(state, treeId);
    /** @type {?} */
    const nodeId = action.payload.id;
    // newState[treeId].nodes.entities[nodeId] = {...newState[treeId].nodes.entities[nodeId], ...{isExpanded: false}};
    newState[treeId].nodes.expanded = newState[treeId].nodes.expanded.filter((/**
     * @param {?} id
     * @return {?}
     */
    (id) => id !== nodeId));
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function insertNode(state, action) {
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const newState = copyState(state, treeId);
    /** @type {?} */
    const parentId = action.payload.parentId;
    /** @type {?} */
    const newNode = {
        id: NEW_NODE_ID,
        treeId: treeId,
        name: 'New data',
        parentId: parentId,
        children: [],
        parents: [],
        isExpanded: false
    };
    newState[treeId].nodes.entities[NEW_NODE_ID] = newNode;
    if (!parentId) {
        newState[treeId].nodes.rootNodes = [...newState[treeId].nodes.rootNodes, NEW_NODE_ID];
    }
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function saveNode(state, action) {
    /** @type {?} */
    const newState = copyState(state, action.payload.treeId);
    /** @type {?} */
    const old = action.payload.oldNode;
    /** @type {?} */
    const newNode = action.payload.node;
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const treeState = newState[treeId].nodes.entities;
    if (treeState[NEW_NODE_ID]) {
        delete treeState[NEW_NODE_ID];
    }
    else {
        delete treeState[old.id];
    }
    /** @type {?} */
    const nodeId = newNode.id;
    treeState[nodeId] = newNode;
    /** @type {?} */
    const parentId = newNode.parentId;
    /** @type {?} */
    const parent = treeState[parentId] || null;
    newNode.parents = [];
    if (parentId) {
        if (parent) {
            if (!parent.children) {
                parent.children = [];
            }
            parent.children.push(nodeId);
            newNode.parents = [...parent.parents, parent.id];
        }
    }
    else if (old.id === NEW_NODE_ID) {
        newState[treeId].nodes.rootNodes = newState[treeId].nodes.rootNodes.filter((/**
         * @param {?} id
         * @return {?}
         */
        (id) => id !== NEW_NODE_ID));
        newState[treeId].nodes.rootNodes.push(nodeId);
    }
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function moveNode(state, action) {
    /** @type {?} */
    const newState = copyState(state, action.payload.treeId);
    /** @type {?} */
    const oldNode = action.payload.source;
    /** @type {?} */
    const newNode = action.payload.target;
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const treeData = newState[treeId];
    /** @type {?} */
    const treeState = newState[treeId].nodes.entities;
    // remove info about removed child
    if (oldNode.parentId) {
        treeState[oldNode.parentId].children = treeState[oldNode.parentId].children.filter((/**
         * @param {?} id
         * @return {?}
         */
        (id) => id !== oldNode.id));
    }
    else {
        treeData.nodes.rootNodes = treeData.nodes.rootNodes.filter((/**
         * @param {?} id
         * @return {?}
         */
        (id) => id !== oldNode.id));
    }
    // add info about moved node
    if (newNode.parentId) {
        /** @type {?} */
        const newParent = treeState[newNode.parentId];
        if (newParent.children) {
            newParent.children.push(newNode.id);
        }
        newNode.parents = [...newParent.parents, newParent.id];
    }
    else {
        treeData.nodes.rootNodes.push(newNode.id);
        newNode.parents = [];
    }
    // replace node data
    treeState[newNode.id] = Object.assign({}, newNode);
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function registerTree(state, action) {
    /** @type {?} */
    const newState = copyState(state);
    newState[action.payload.treeId] = {
        nodes: {
            entities: Object.assign({}, emptyTreeData.nodes.entities),
            previouslySelected: emptyTreeData.nodes.previouslySelected,
            selected: emptyTreeData.nodes.selected,
            rootNodes: [...emptyTreeData.nodes.rootNodes],
            expanded: [...emptyTreeData.nodes.expanded]
        },
        configuration: Object.assign({}, emptyTreeData.configuration)
    };
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function setAllNodes(state, action) {
    /** @type {?} */
    const newState = copyState(state, action.payload.treeId);
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const nodes = action.payload.nodes;
    /** @type {?} */
    const newNodes = {};
    /** @type {?} */
    const ids = nodes.map((/**
     * @param {?} nodeData
     * @return {?}
     */
    (nodeData) => nodeData.id));
    nodes.forEach((/**
     * @param {?} nodeData
     * @return {?}
     */
    (nodeData) => {
        nodeData.treeId = treeId;
        newNodes[nodeData.id] = nodeData;
        if (nodeData.parentId === null) {
            newState[treeId].nodes.rootNodes.push(nodeData.id);
        }
    }));
    newState[treeId].nodes.rootNodes.forEach((/**
     * @param {?} id
     * @return {?}
     */
    (id) => updateParents(newNodes, id)));
    newState[treeId].nodes.entities = newNodes;
    return newState;
}
/**
 * @param {?} nodes
 * @param {?} nodeId
 * @param {?=} parents
 * @return {?}
 */
function updateParents(nodes, nodeId, parents = []) {
    /** @type {?} */
    const node = nodes[nodeId];
    if (node) {
        node.parents = [...parents];
        if (node.children.length > 0) {
            /** @type {?} */
            const newParents = [...parents, ...[node.id]];
            node.children.forEach((/**
             * @param {?} childId
             * @return {?}
             */
            childId => updateParents(nodes, childId, newParents)));
        }
    }
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function markTreeAsFullyLoaded(state, action) {
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const newState = copyState(state, treeId);
    newState[treeId].configuration = Object.assign({}, newState[treeId].configuration, { isFullyLoaded: true });
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function setConfiguration(state, action) {
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const newState = copyState(state, treeId);
    newState[treeId].configuration = Object.assign({}, newState[treeId].configuration, action.payload.configuration);
    return newState;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function selectNode(state, action) {
    /** @type {?} */
    const treeId = action.payload.treeId;
    /** @type {?} */
    const node = action.payload.node;
    /** @type {?} */
    const newState = copyState(state, treeId);
    newState[treeId].nodes.previouslySelected = newState[treeId].nodes.selected;
    newState[treeId].nodes.selected = node ? node.id : null;
    return newState;
}
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function treeReducer(state = {}, action) {
    switch (action.type) {
        case TreeActionTypes.TREE_REGISTER:
            return registerTree(state, action);
        case TreeActionTypes.TREE_SAVE_NODE_SUCCESS:
            return saveNode(state, action);
        case TreeActionTypes.TREE_DELETE_NODE_SUCCESS:
            return removeNode(state, action);
        case TreeActionTypes.TREE_INSERT_NODE:
            return insertNode(state, action);
        case TreeActionTypes.TREE_LOAD_SUCCESS:
            return loadNodes(state, action);
        case TreeActionTypes.TREE_MOVE_NODE_SUCCESS:
            return moveNode(state, action);
        case TreeActionTypes.TREE_SET_ALL_NODES:
            return setAllNodes(state, action);
        case TreeActionTypes.TREE_MARK_AS_FULLY_LOADED:
            return markTreeAsFullyLoaded(state, action);
        case TreeActionTypes.TREE_SET_CONFIGURATION:
            return setConfiguration(state, action);
        case TreeActionTypes.TREE_EXPAND_NODE:
            return expandNode(state, action);
        case TreeActionTypes.TREE_COLLAPSE_NODE:
            return collapseNode(state, action);
        case TreeActionTypes.TREE_SELECT_NODE:
            return selectNode(state, action);
        case TreeActionTypes.TREE_DELETE_NODE:
        case TreeActionTypes.TREE_EDIT_NODE_START:
        case TreeActionTypes.TREE_LOAD:
        case TreeActionTypes.TREE_MOVE_NODE:
        case TreeActionTypes.TREE_SAVE_NODE:
            return state;
        default:
            return state;
    }
}
/** @type {?} */
const treeStateSelector = createFeatureSelector('trees');
/**
 * @param {?} treeId
 * @return {?}
 */
function treeSelector(treeId) {
    return createSelector(treeStateSelector, (/**
     * @param {?} state
     * @return {?}
     */
    (state) => state[treeId] || null));
}
/**
 * @param {?} treeId
 * @return {?}
 */
function treeConfigurationSelector(treeId) {
    return createSelector(treeStateSelector, (/**
     * @param {?} state
     * @return {?}
     */
    (state) => state[treeId].configuration || null));
}
/**
 * @param {?} treeId
 * @return {?}
 */
function expandedNodesSelector(treeId) {
    return createSelector(treeStateSelector, (/**
     * @param {?} state
     * @return {?}
     */
    (state) => state[treeId].nodes.expanded || []));
}
/**
 * @param {?} treeId
 * @return {?}
 */
function selectedNodeSelector(treeId) {
    return createSelector(treeStateSelector, (/**
     * @param {?} state
     * @return {?}
     */
    (state) => state[treeId].nodes.selected || null));
}
/**
 * @param {?} treeId
 * @return {?}
 */
function previouslySelectedNodeSelector(treeId) {
    return createSelector(treeStateSelector, (/**
     * @param {?} state
     * @return {?}
     */
    (state) => state[treeId].nodes.previouslySelected || null));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const isEqual = _isEqual;
class TreeModel {
    /**
     * @param {?} store
     * @param {?} treeData$
     * @param {?} configuration
     * @param {?=} _fullyLoaded
     */
    constructor(store, treeData$, configuration, _fullyLoaded = false) {
        this.store = store;
        this.treeData$ = treeData$;
        this.configuration = configuration;
        this._fullyLoaded = _fullyLoaded;
        this.selected = null;
        this.previouslySelected = null;
        this.subscription = new Subscription();
        this.nodes$ = this.treeData$
            .pipe(distinctUntilChanged((/**
         * @param {?} prev
         * @param {?} next
         * @return {?}
         */
        (prev, next) => {
            return isEqual(prev.nodes.entities, next.nodes.entities);
        })), map((/**
         * @param {?} treeData
         * @return {?}
         */
        (treeData) => treeData.nodes.entities)));
        this.rootNodes$ = this.treeData$
            .pipe(map((/**
         * @param {?} treeData
         * @return {?}
         */
        (treeData) => treeData.nodes.rootNodes.map((/**
         * @param {?} id
         * @return {?}
         */
        (id) => treeData.nodes.entities[id])).sort(this.sortNodes))), distinctUntilChanged());
        this.currentSelectedNode$ = this.treeData$
            .pipe(map((/**
         * @param {?} treeData
         * @return {?}
         */
        (treeData) => {
            /** @type {?} */
            const nodesData = treeData.nodes;
            /** @type {?} */
            const selectedId = nodesData.selected;
            return selectedId ? nodesData.entities[selectedId] : null;
        })));
        this.initConfiguration();
        this.subscribeExpanded();
        this.subscribeSelected();
        this.subscribePreviouslySelected();
    }
    /**
     * @return {?}
     */
    get treeId() {
        return this.configuration.treeId;
    }
    /**
     * @return {?}
     */
    get isFullyLoaded() {
        return this._fullyLoaded;
    }
    /**
     * @return {?}
     */
    destroy() {
        this.subscription.unsubscribe();
    }
    /**
     * @return {?}
     */
    getParentsList() {
        return combineLatest(this.currentSelectedNode$, this.nodes$)
            .pipe(map((/**
         * @param {?} __0
         * @return {?}
         */
        ([currentNode, nodes]) => {
            if (!Boolean(currentNode)) {
                return [];
            }
            /** @type {?} */
            const parents = currentNode.parents.map((/**
             * @param {?} id
             * @return {?}
             */
            id => nodes[id]));
            parents.push(currentNode);
            return parents;
        })));
    }
    /**
     * @param {?} nodeId
     * @return {?}
     */
    getChildren(nodeId) {
        return this.nodes$
            .pipe(map((/**
         * @param {?} state
         * @return {?}
         */
        (state) => this.getNodesByParentId(state, nodeId))), map((/**
         * @param {?} nodes
         * @return {?}
         */
        (nodes) => {
            return [...nodes].sort(this.sortNodes);
        })));
    }
    /**
     * @param {?} path
     * @return {?}
     */
    initPath(path) {
        this.store.dispatch(new TreeLoadPathAction({ treeId: this.configuration.treeId, ids: path }));
    }
    /**
     * @param {?} node
     * @return {?}
     */
    isExpanded(node) {
        if (!node) {
            return false;
        }
        return this.expanded.has(node.id);
    }
    /**
     * @param {?} node
     * @return {?}
     */
    isSelected(node) {
        if (!node) {
            return false;
        }
        return this.selected === node.id;
    }
    /**
     * @param {?} nodeId
     * @return {?}
     */
    wasPreviouslySelected(nodeId) {
        return this.previouslySelected === nodeId;
    }
    /**
     * @private
     * @return {?}
     */
    initConfiguration() {
        /** @type {?} */
        const defaultConfiguration = {
            disableMoveNodes: false,
            dragZone: null,
            dropZone: null,
            treeId: 'tree',
            showAddButton: true,
            isAnimation: false,
        };
        for (const key in defaultConfiguration) {
            if (this.configuration[key] === undefined) {
                this.configuration[key] = defaultConfiguration[key];
            }
        }
    }
    /**
     * @private
     * @param {?} state
     * @param {?} id
     * @return {?}
     */
    getNodesByParentId(state, id) {
        return Object.keys(state)
            .filter((/**
         * @param {?} key
         * @return {?}
         */
        (key) => state[key].parentId === id))
            .map((/**
         * @param {?} key
         * @return {?}
         */
        (key) => state[key]));
    }
    /**
     * @private
     * @param {?} first
     * @param {?} second
     * @return {?}
     */
    sortNodes(first, second) {
        if (second.id === NEW_NODE_ID) {
            return -1;
        }
        return first.name > second.name ? 1 : -1;
    }
    /**
     * @private
     * @return {?}
     */
    subscribeExpanded() {
        this.subscription.add(this.store
            .pipe(select(expandedNodesSelector(this.treeId)))
            .subscribe((/**
         * @param {?} expanded
         * @return {?}
         */
        (expanded) => this.expanded = new Set(expanded))));
    }
    /**
     * @private
     * @return {?}
     */
    subscribeSelected() {
        this.subscription.add(this.store
            .pipe(select(selectedNodeSelector(this.treeId)))
            .subscribe((/**
         * @param {?} selected
         * @return {?}
         */
        (selected) => this.selected = selected)));
    }
    /**
     * @private
     * @return {?}
     */
    subscribePreviouslySelected() {
        this.subscription.add(this.store
            .pipe(select(previouslySelectedNodeSelector(this.treeId)))
            .subscribe((/**
         * @param {?} selected
         * @return {?}
         */
        (selected) => this.previouslySelected = selected)));
    }
}
if (false) {
    /** @type {?} */
    TreeModel.prototype.nodes$;
    /** @type {?} */
    TreeModel.prototype.rootNodes$;
    /** @type {?} */
    TreeModel.prototype.currentSelectedNode$;
    /**
     * @type {?}
     * @private
     */
    TreeModel.prototype.expanded;
    /**
     * @type {?}
     * @private
     */
    TreeModel.prototype.selected;
    /**
     * @type {?}
     * @private
     */
    TreeModel.prototype.previouslySelected;
    /**
     * @type {?}
     * @private
     */
    TreeModel.prototype.subscription;
    /**
     * @type {?}
     * @protected
     */
    TreeModel.prototype.store;
    /**
     * @type {?}
     * @protected
     */
    TreeModel.prototype.treeData$;
    /** @type {?} */
    TreeModel.prototype.configuration;
    /**
     * @type {?}
     * @protected
     */
    TreeModel.prototype._fullyLoaded;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @return {?}
 */
function expand() {
    return trigger('expand', [
        state('*', style({ 'overflow-y': 'hidden' })),
        state('void', style({ 'overflow-y': 'hidden' })),
        transition('* => void', [
            style({ height: '*' }),
            animate(300, style({ height: 0 }))
        ]),
        transition('void => *', [
            style({ height: '0' }),
            animate(300, style({ height: '*' }))
        ])
    ]);
}
class ItemComponent {
    /**
     * @param {?} contextMenuService
     * @param {?} actions$
     * @param {?} store
     * @param {?} cdr
     */
    constructor(contextMenuService, actions$, store, cdr) {
        this.contextMenuService = contextMenuService;
        this.actions$ = actions$;
        this.store = store;
        this.cdr = cdr;
        this.isExpanded = false;
        this.isSelected = false;
        /**
         * Form field to change data name
         */
        this.nameField = new FormControl();
        this.isEditMode = false;
        this.children$ = empty();
        this.isStartSave = false;
        this.subscription = new Subscription();
    }
    /**
     * Node instance
     * @param {?} node
     * @return {?}
     */
    set node(node) {
        this._node = node;
        this.initEditModeIfNeeded(node);
    }
    /**
     * @return {?}
     */
    get node() {
        return this._node;
    }
    /**
     * @param {?} values
     * @return {?}
     */
    ngOnChanges(values) {
        // if node is added to the tree then some part of nodes is moving down
        // and the new one is inserted, then all sub nodes should be rewritten
        /** @type {?} */
        const node = values.node;
        if (node && !node.firstChange && node.previousValue.id !== node.currentValue.id) {
            this.children$ = this.getChildren();
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.children$ = this.getChildren();
        this.subscribeForOnEdit();
        this.subscription.add(this.store
            .pipe(select(previouslySelectedNodeSelector(this.node.treeId)), filter((/**
         * @param {?} previouslySelected
         * @return {?}
         */
        (previouslySelected) => previouslySelected === this.node.id)))
            .subscribe((/**
         * @return {?}
         */
        () => this.cdr.markForCheck())));
    }
    /**
     * Collapse node
     * @return {?}
     */
    collapse() {
        this.store.dispatch(new TreeCollapseNodeAction({
            treeId: this.treeModel.treeId,
            id: this.node.id,
        }));
    }
    /**
     * Expand node
     * @return {?}
     */
    expand() {
        this.store.dispatch(new TreeExpandNodeAction({ treeId: this.treeModel.treeId, id: this.node.id }));
    }
    /**
     * @return {?}
     */
    onBlur() {
        if (this.isStartSave) {
            this.isStartSave = false;
        }
        else {
            this.undoChanges();
        }
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onChange(event) {
        event.stopPropagation();
        if (event.keyCode === 27) {
            this.undoChanges();
        }
        else if (event.keyCode === 13) {
            this.isStartSave = true;
            /** @type {?} */
            const node = {
                id: this.node.id,
                treeId: this.node.treeId,
                name: this.nameField.value,
                parentId: this.node.parentId,
                children: this.node.children,
                parents: this.node.parents,
                isExpanded: false
            };
            this.store.dispatch(new TreeSaveNodeAction({
                treeId: this.treeModel.treeId,
                node,
            }));
            this.isEditMode = false;
        }
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onContextMenu($event) {
        if (!this.treeModel.configuration.disableContextMenu) {
            this.contextMenuService.show.next({
                contextMenu: this.contextMenu,
                event: $event,
                item: this.node
            });
        }
        $event.preventDefault();
        $event.stopPropagation();
    }
    /**
     * @return {?}
     */
    onSelect() {
        if (this.isSelected) {
            this.store.dispatch(new TreeSelectNodeAction({
                treeId: this.treeModel.treeId,
                node: null,
            }));
        }
        else {
            this.store.dispatch(new TreeSelectNodeAction({
                treeId: this.treeModel.treeId,
                node: this.node,
            }));
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    trackByFn(item) {
        return item.id;
    }
    /**
     * @protected
     * @return {?}
     */
    getChildren() {
        return this.treeModel.getChildren(this.node.id);
    }
    /**
     * @protected
     * @param {?} node
     * @return {?}
     */
    initEditModeIfNeeded(node) {
        if (!node) {
            return;
        }
        this.isEditMode = node.id === NEW_NODE_ID;
        if (this.isEditMode) {
            this.nameField.setValue('');
            this.setFocus();
        }
    }
    /**
     * @protected
     * @return {?}
     */
    isNewNode() {
        return this.node.id === NEW_NODE_ID;
    }
    /**
     * @protected
     * @return {?}
     */
    setFocus() {
        setTimeout((/**
         * @return {?}
         */
        () => this.input.nativeElement.focus()), 0);
    }
    /**
     * @protected
     * @return {?}
     */
    subscribeForOnEdit() {
        this.subscription.add(this.actions$
            .ofType(TreeActionTypes.TREE_EDIT_NODE_START)
            .pipe(filter((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload.node === this.node)))
            .subscribe((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            this.nameField.setValue(this.node.name);
            this.isEditMode = true;
            this.cdr.markForCheck();
            this.setFocus();
        })));
    }
    /**
     * @protected
     * @return {?}
     */
    undoChanges() {
        this.isEditMode = false;
        if (this.isNewNode()) {
            this.store.dispatch(new TreeDeleteNodeAction({
                treeId: this.treeModel.treeId,
                node: this.node,
            }));
        }
    }
}
ItemComponent.decorators = [
    { type: Component, args: [{
                encapsulation: ViewEncapsulation.None,
                selector: 'ri-tree-item',
                template: "<div class=\"tree-item\"\n     [ngClass]=\"{'tree-item-selected': isSelected && !treeModel.wasPreviouslySelected(node.id)}\"\n     (contextmenu)=\"onContextMenu($event)\"\n     riDroppable\n     riDraggable\n     [dragZone]=\"treeModel.configuration.dragZone\"\n     [dropConfig]=\"{dropAllowedCssClass: 'drop-allowed', dropZone: treeModel.configuration.dropZone}\"\n     [data]=\"node\"\n     id=\"node-{{node.id}}\"\n>\n  <i *ngIf=\"!isExpanded\" (click)=\"expand()\" class=\"fa fa-caret-right pointer\"></i>\n  <i *ngIf=\"isExpanded\" (click)=\"collapse()\" class=\"fa fa-caret-down pointer\"></i>\n  <span *ngIf=\"!isEditMode\" class=\"tree-item-name\" (click)=\"onSelect()\">{{node.name}}</span>\n  <form name=\"form\">\n    <input #inputElement type=\"text\" class=\"form-control\" *ngIf=\"isEditMode\" [formControl]=\"nameField\"\n           name=\"name\" (keydown)=\"onChange($event)\" (blur)=\"onBlur()\"/>\n  </form>\n</div>\n<div class=\"tree\" *ngIf=\"isExpanded\" [@expand]>\n  <ri-tree-item *ngFor=\"let child of children$ | async; trackBy: trackByFn\"\n                [node]=\"child\"\n                [treeModel]=\"treeModel\"\n                [isExpanded]=\"treeModel.isExpanded(child)\"\n                [isSelected]=\"treeModel.isSelected(child)\"\n                [contextMenu]=\"contextMenu\"></ri-tree-item>\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                animations: [expand()],
                styles: [""]
            }] }
];
/** @nocollapse */
ItemComponent.ctorParameters = () => [
    { type: ContextMenuService },
    { type: Actions },
    { type: Store },
    { type: ChangeDetectorRef }
];
ItemComponent.propDecorators = {
    input: [{ type: ViewChild, args: ['inputElement', { static: false },] }],
    node: [{ type: Input }],
    treeModel: [{ type: Input }],
    contextMenu: [{ type: Input }],
    isExpanded: [{ type: Input }],
    isSelected: [{ type: Input }]
};
if (false) {
    /**
     * Input field where we can change data name
     * @type {?}
     */
    ItemComponent.prototype.input;
    /** @type {?} */
    ItemComponent.prototype.treeModel;
    /** @type {?} */
    ItemComponent.prototype.contextMenu;
    /** @type {?} */
    ItemComponent.prototype.isExpanded;
    /** @type {?} */
    ItemComponent.prototype.isSelected;
    /**
     * Form field to change data name
     * @type {?}
     */
    ItemComponent.prototype.nameField;
    /** @type {?} */
    ItemComponent.prototype.isEditMode;
    /** @type {?} */
    ItemComponent.prototype.children$;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype.isStartSave;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype.subscription;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype._node;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype.contextMenuService;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype.actions$;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype.store;
    /**
     * @type {?}
     * @protected
     */
    ItemComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DragAndDrop {
    constructor() {
        this.dropStream$ = new Subject();
        this.dragStream$ = new BehaviorSubject(null);
        this.drop$ = this.dropStream$
            .pipe(withLatestFrom(this.dragStream$), map((/**
         * @param {?} __0
         * @return {?}
         */
        ([dropNode, dragNode]) => {
            return { dragNode: dragNode, dropNode: dropNode, type: dragNode.type };
        })));
    }
    /**
     * @param {?} dragElement
     * @return {?}
     */
    dragStart(dragElement) {
        this.dragStream$.next(dragElement);
    }
    /**
     * @param {?} dropElement
     * @return {?}
     */
    dragEnd(dropElement) {
        this.dropStream$.next(dropElement);
    }
    /**
     * @return {?}
     */
    getDragStream() {
        return this.dragStream$;
    }
    /**
     * @return {?}
     */
    getLastDragElement() {
        return this.dragStream$.getValue();
    }
}
DragAndDrop.DROP_DATA_TYPE = 'TREE_NODE';
DragAndDrop.decorators = [
    { type: Injectable }
];
/** @nocollapse */
DragAndDrop.ctorParameters = () => [];
if (false) {
    /** @type {?} */
    DragAndDrop.DROP_DATA_TYPE;
    /**
     * @type {?}
     * @protected
     */
    DragAndDrop.prototype.dropStream$;
    /**
     * @type {?}
     * @protected
     */
    DragAndDrop.prototype.dragStream$;
    /** @type {?} */
    DragAndDrop.prototype.drop$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TREE_TRANSLATION_TOKEN = new InjectionToken('[TREE[ Translation service');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TreeComponent {
    /**
     * @param {?} store
     * @param {?} dragAndDrop
     * @param {?} treeTranslationService
     */
    constructor(store, dragAndDrop, treeTranslationService) {
        this.store = store;
        this.dragAndDrop = dragAndDrop;
        this.treeTranslationService = treeTranslationService;
        /**
         * List of default options for context menu
         */
        this.defaultOptions = [
            {
                name: 'onEdit',
                text: this.treeTranslationService.RI_TREE_LBL_EDIT_NODE,
                iconCls: 'fa fa-edit'
            },
            {
                name: 'onDelete',
                text: this.treeTranslationService.RI_TREE_LBL_REMOVE_NODE,
                iconCls: 'fa fa-trash'
            }
        ];
        /**
         * List of context menu items
         */
        this.menuList = [];
        this.subscription = new Subscription();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.registerMove();
        this.rootNodes$ = this.treeModel.rootNodes$;
        this.subscription.add(this.treeModel.currentSelectedNode$
            .subscribe((/**
         * @param {?} node
         * @return {?}
         */
        (node) => this.currentSelectedNode = node)));
    }
    /**
     * @param {?} data
     * @return {?}
     */
    ngOnChanges(data) {
        this.menuList = [];
        this.defaultOptions.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => this.menuList.push(item)));
    }
    /**
     * @return {?}
     */
    onAdd() {
        /** @type {?} */
        const parentId = this.currentSelectedNode ? this.currentSelectedNode.id : null;
        this.store.dispatch(new TreeInsertNodeAction({ treeId: this.treeModel.treeId, parentId }));
    }
    /**
     * On select item from context menu
     *
     * @param {?} name - name of the event
     * @param {?} node - data item
     * @return {?}
     */
    onContextMenuClick(name, node) {
        switch (name) {
            case 'onEdit':
                event.stopPropagation();
                this.store.dispatch(new TreeEditNodeStartAction({ node }));
                break;
            case 'onDelete':
                this.store.dispatch(new TreeDeleteNodeAction({ treeId: this.treeModel.treeId, node }));
                break;
            default:
                console.warn('Unknown context menu action: ' + name);
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    trackByFn(item) {
        return item.id;
    }
    /**
     * Register data "move event"
     * @protected
     * @return {?}
     */
    registerMove() {
        if (this.treeModel.configuration.disableMoveNodes) {
            return;
        }
        this.dragAndDrop.drop$
            .pipe(filter((/**
         * @param {?} data
         * @return {?}
         */
        (data) => {
            if (data.type === DragAndDrop.DROP_DATA_TYPE) {
                if (data.dropNode) {
                    return data.dropNode.data.treeId === this.treeModel.treeId;
                }
                else {
                    return data.dragNode.data.treeId === this.treeModel.treeId;
                }
            }
            else {
                if (data.dropNode && data.dropNode.zones && data.dropNode.zones.indexOf(data.dragNode.zoneId) === -1) {
                    return false;
                }
                return true;
            }
        })))
            .subscribe((/**
         * @param {?} data
         * @return {?}
         */
        (data) => {
            /** @type {?} */
            const dropNode = data.dropNode ? data.dropNode.data : null;
            this.store.dispatch(new TreeMoveNodeAction({
                sourceOfDroppedData: data.type,
                treeId: this.treeModel.treeId,
                oldNode: data.dragNode.data,
                node: dropNode
            }));
        }));
    }
}
TreeComponent.decorators = [
    { type: Component, args: [{
                encapsulation: ViewEncapsulation.None,
                selector: 'ri-tree',
                template: "<div class=\"tree\">\n  <button *ngIf=\"treeModel.configuration.showAddButton\" class=\"btn btn-dark add-node-button\" (click)=\"onAdd()\">\n    <i class=\"fa fa-plus\"></i> {{treeTranslationService.RI_TREE_LBL_ADD_NODE}}\n  </button>\n  <!--@formatter:off-->\n  <div #customTemplate><ng-content></ng-content></div>\n  <!--@formatter:on-->\n  <div *ngIf=\"customTemplate.childNodes.length === 0\">\n    <ri-tree-item\n      class=\"root-node\"\n      *ngFor=\"let node of rootNodes$ | async; trackBy: trackByFn\"\n      [node]=\"node\"\n      [treeModel]=\"treeModel\"\n      [isSelected]=\"treeModel.isSelected(node)\"\n      [isExpanded]=\"treeModel.isExpanded(node)\"\n      [contextMenu]=\"contextMenu\"></ri-tree-item>\n  </div>\n  <ri-dropzone [treeModel]=\"treeModel\"></ri-dropzone>\n  <context-menu id=\"context-menu-{{treeModel.treeId}}\" #contextMenu>\n    <ng-template *ngFor=\"let menuItem of menuList\" contextMenuItem let-item\n                 (execute)=\"onContextMenuClick(menuItem.name, $event.item)\">\n      <span class=\"{{menuItem.iconCls}}\" style=\"width: 20px; display: inline-block;\"></span>\n      {{menuItem.text}}\n    </ng-template>\n  </context-menu>\n</div>\n",
                styles: [".tree{list-style-type:none;margin:0;padding-left:0;position:relative}.tree .dropdown{position:inherit}.tree .dropdown-menu{position:absolute!important}.tree .pointer{cursor:pointer}.tree .tree{margin-left:20px}.tree .tree-edit-btn,.tree .tree-remove-btn{display:none}.tree .tree-item{padding:2px 0}.tree .tree-item.drop-allowed .tree-item-name{background-color:rgba(255,0,0,.3)}.tree .tree-item.tree-item-selected>.tree-item-name{padding:0 1px;border:1px solid #4684ee;background-color:#549dee}.tree .tree-item i{text-align:center}.tree .tree-item .no-children{display:inline-block;width:8px}.tree .tree-item .tree-item-name{display:inline-block;line-height:22px;height:22px;padding:0 2px;cursor:pointer}.tree .tree-item .tree-item-name:hover{background-color:rgba(161,197,238,.2)}.tree .tree-item .tree-item-name:hover .tree-edit-btn,.tree .tree-item .tree-item-name:hover .tree-remove-btn,.tree .tree-item form{display:inline-block}.tree .tree-item form input{width:auto}"]
            }] }
];
/** @nocollapse */
TreeComponent.ctorParameters = () => [
    { type: Store },
    { type: DragAndDrop },
    { type: undefined, decorators: [{ type: Inject, args: [TREE_TRANSLATION_TOKEN,] }] }
];
TreeComponent.propDecorators = {
    treeModel: [{ type: Input }],
    contextMenu: [{ type: ViewChild, args: ['contextMenu', { static: true },] }]
};
if (false) {
    /** @type {?} */
    TreeComponent.prototype.treeModel;
    /** @type {?} */
    TreeComponent.prototype.contextMenu;
    /**
     * List of default options for context menu
     * @type {?}
     * @private
     */
    TreeComponent.prototype.defaultOptions;
    /**
     * List of context menu items
     * @type {?}
     */
    TreeComponent.prototype.menuList;
    /** @type {?} */
    TreeComponent.prototype.rootNodes$;
    /**
     * @type {?}
     * @protected
     */
    TreeComponent.prototype.currentSelectedNode;
    /**
     * @type {?}
     * @protected
     */
    TreeComponent.prototype.subscription;
    /**
     * @type {?}
     * @protected
     */
    TreeComponent.prototype.store;
    /**
     * @type {?}
     * @protected
     */
    TreeComponent.prototype.dragAndDrop;
    /** @type {?} */
    TreeComponent.prototype.treeTranslationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DraggableDirective {
    /**
     * @param {?} el
     * @param {?} renderer
     * @param {?} dragAndDrop
     */
    constructor(el, renderer, dragAndDrop) {
        this.el = el;
        this.renderer = renderer;
        this.dragAndDrop = dragAndDrop;
        this.dragZone = null;
        this.sourceType = DragAndDrop.DROP_DATA_TYPE;
        this.dragEnabled = true;
        renderer.listen(el.nativeElement, 'dragstart', (/**
         * @param {?} $event
         * @return {?}
         */
        ($event) => {
            if (this.dragEnabled) {
                this.onDragStart($event);
            }
        }));
        renderer.listen(el.nativeElement, 'dragend', (/**
         * @return {?}
         */
        () => {
            // on drag end we reset last drag element (this event is fired after drop)
            this.dragAndDrop.dragStart(null);
        }));
    }
    /**
     * @private
     * @param {?} $event
     * @return {?}
     */
    onDragStart($event) {
        this.dragAndDrop.dragStart({ zoneId: this.dragZone, data: this.data, type: this.sourceType });
        $event.dataTransfer.effectAllowed = 'copy';
        $event.dataTransfer.dropEffect = 'copy';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.el.nativeElement.draggable = this.dragEnabled;
        if (!this.data) {
            throw new Error('DraggableDirective needs data');
        }
    }
}
DraggableDirective.decorators = [
    { type: Directive, args: [{
                selector: '[riDraggable]'
            },] }
];
/** @nocollapse */
DraggableDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer },
    { type: DragAndDrop }
];
DraggableDirective.propDecorators = {
    data: [{ type: Input }],
    dragZone: [{ type: Input }],
    sourceType: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    DraggableDirective.prototype.data;
    /** @type {?} */
    DraggableDirective.prototype.dragZone;
    /** @type {?} */
    DraggableDirective.prototype.sourceType;
    /** @type {?} */
    DraggableDirective.prototype.dragEnabled;
    /**
     * @type {?}
     * @protected
     */
    DraggableDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    DraggableDirective.prototype.renderer;
    /**
     * @type {?}
     * @protected
     */
    DraggableDirective.prototype.dragAndDrop;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DropConfig() { }
if (false) {
    /** @type {?|undefined} */
    DropConfig.prototype.dropAllowedCssClass;
    /** @type {?|undefined} */
    DropConfig.prototype.dropZone;
}
class DroppableDirective {
    /**
     * @param {?} el
     * @param {?} renderer
     * @param {?} dragAndDrop
     */
    constructor(el, renderer, dragAndDrop) {
        this.el = el;
        this.renderer = renderer;
        this.dragAndDrop = dragAndDrop;
        this.dropConfig = {};
        this.isDropAllowed = (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            const lastDragElement = this.dragAndDrop.getLastDragElement();
            /** @type {?} */
            const source = lastDragElement.data;
            /** @type {?} */
            const target = this.data;
            /** @type {?} */
            const dropZone = this.dropConfig.dropZone;
            if (dropZone && dropZone.length > 0 && dropZone.indexOf(lastDragElement.zoneId) === -1) {
                return false;
            }
            // todo: check drag and drop zones
            return !(source === target || target.id === source.parentId || target.parents.indexOf(source.id) > -1);
        });
        renderer.listen(el.nativeElement, 'dragover', (/**
         * @param {?} $event
         * @return {?}
         */
        ($event) => {
            $event.preventDefault();
            /** @type {?} */
            const dropAllowed = this.isDropAllowed();
            this.changeTargetCursor($event, dropAllowed);
            this.toggleDropClass(dropAllowed);
        }));
        renderer.listen(el.nativeElement, 'dragleave', (/**
         * @param {?} $event
         * @return {?}
         */
        ($event) => {
            $event.preventDefault();
            this.toggleDropClass(false);
        }));
        renderer.listen(el.nativeElement, 'drop', (/**
         * @return {?}
         */
        () => {
            this.toggleDropClass(false);
            if (this.isDropAllowed()) {
                this.dragAndDrop.dragEnd({ zones: this.dropConfig.dropZone, data: this.data });
            }
        }));
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.initConfig();
        if (!this.data) {
            throw new Error('DroppableDirective needs data');
        }
    }
    /**
     * Add or remove additional class when drop allowed
     * @private
     * @param {?=} dropAllowed
     * @return {?}
     */
    toggleDropClass(dropAllowed = false) {
        this.renderer.setElementClass(this.el.nativeElement, this.dropConfig.dropAllowedCssClass, dropAllowed);
    }
    /**
     * Change drag event cursor
     * @private
     * @param {?} $event
     * @param {?=} add
     * @return {?}
     */
    changeTargetCursor($event, add = false) {
        /** @type {?} */
        const cursorType = add ? 'copy' : 'none';
        $event.dataTransfer.effectAllowed = cursorType;
        $event.dataTransfer.dropEffect = cursorType;
    }
    /**
     * initialize configuration options, use default or passed
     * @private
     * @return {?}
     */
    initConfig() {
        /** @type {?} */
        const defaultConfig = {
            dropAllowedCssClass: 'drop-allowed'
        };
        for (const key in defaultConfig) {
            if (defaultConfig.hasOwnProperty(key)) {
                this.dropConfig[key] = this.dropConfig[key] || defaultConfig[key];
            }
        }
    }
}
DroppableDirective.decorators = [
    { type: Directive, args: [{
                selector: '[riDroppable]'
            },] }
];
/** @nocollapse */
DroppableDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer },
    { type: DragAndDrop }
];
DroppableDirective.propDecorators = {
    data: [{ type: Input }],
    dropConfig: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    DroppableDirective.prototype.data;
    /** @type {?} */
    DroppableDirective.prototype.dropConfig;
    /**
     * @type {?}
     * @private
     */
    DroppableDirective.prototype.isDropAllowed;
    /**
     * @type {?}
     * @protected
     */
    DroppableDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    DroppableDirective.prototype.renderer;
    /**
     * @type {?}
     * @protected
     */
    DroppableDirective.prototype.dragAndDrop;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DropzoneComponent {
    /**
     * @param {?} dragAndDrop
     * @param {?} treeTranslationService
     */
    constructor(dragAndDrop, treeTranslationService) {
        this.dragAndDrop = dragAndDrop;
        this.treeTranslationService = treeTranslationService;
        this.dropZone = [];
        /** @type {?} */
        const isDragStart$ = this.dragAndDrop.getDragStream()
            .pipe(map((/**
         * @param {?} dragElement
         * @return {?}
         */
        (dragElement) => {
            /** @type {?} */
            const isDragElement = !!dragElement && !!dragElement.data;
            if (isDragElement) {
                if (dragElement.type === DragAndDrop.DROP_DATA_TYPE) {
                    /** @type {?} */
                    const isNotRootElement = dragElement.data.parentId;
                    /** @type {?} */
                    const isFromCurrentTree = dragElement.data.treeId === this.treeModel.treeId;
                    return (isNotRootElement && isFromCurrentTree) ? true : false;
                }
                else {
                    return true;
                }
            }
            return false;
        })));
        /** @type {?} */
        const isDragEnd$ = this.dragAndDrop.drop$
            .pipe(map((/**
         * @param {?} data
         * @return {?}
         */
        (data) => {
            return false;
        })));
        this.isOpen$ = merge(isDragStart$, isDragEnd$);
    }
    /**
     * @return {?}
     */
    onDrop() {
        this.dragAndDrop.dragEnd(null);
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onDragOver($event) {
        $event.preventDefault();
    }
}
DropzoneComponent.decorators = [
    { type: Component, args: [{
                selector: 'ri-dropzone',
                template: "<div *ngIf=\"isOpen$ | async\" (drop)=\"onDrop()\" (dragover)=\"onDragOver($event)\" class=\"dropzone\">\n  {{treeTranslationService.RI_TREE_LBL_DROP_ZONE}}\n</div>\n",
                styles: [".dropzone{display:inline-block;border:1px dotted red;padding:10px;background-color:rgba(255,0,0,.3)}"]
            }] }
];
/** @nocollapse */
DropzoneComponent.ctorParameters = () => [
    { type: DragAndDrop },
    { type: undefined, decorators: [{ type: Inject, args: [TREE_TRANSLATION_TOKEN,] }] }
];
DropzoneComponent.propDecorators = {
    treeModel: [{ type: Input }],
    dropZone: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    DropzoneComponent.prototype.treeModel;
    /** @type {?} */
    DropzoneComponent.prototype.dropZone;
    /** @type {?} */
    DropzoneComponent.prototype.isOpen$;
    /** @type {?} */
    DropzoneComponent.prototype.dragAndDrop;
    /** @type {?} */
    DropzoneComponent.prototype.treeTranslationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NodeDispatcherService {
    constructor() {
        this.nodeServices = {};
    }
    /**
     * @param {?} name
     * @param {?} nodeService
     * @return {?}
     */
    registerService(name, nodeService) {
        this.nodeServices[name] = nodeService;
    }
    /**
     * @param {?} name
     * @return {?}
     */
    get(name) {
        if (Boolean(this.nodeServices[name])) {
            return this.nodeServices[name];
        }
        else {
            // default node service provider
            throw Error(`No tree service with name ${name}`);
        }
    }
}
NodeDispatcherService.decorators = [
    { type: Injectable }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    NodeDispatcherService.prototype.nodeServices;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TreeEffectsService {
    /**
     * @param {?} actions$
     * @param {?} nodeDispatcherService
     * @param {?} store
     */
    constructor(actions$, nodeDispatcherService, store) {
        this.actions$ = actions$;
        this.nodeDispatcherService = nodeDispatcherService;
        this.store = store;
        this.register$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_REGISTER), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            if (action.payload.silent) {
                return new TreeSetAllNodesAction({ treeId: action.payload.treeId, nodes: action.payload.nodes });
            }
            else {
                return new TreeLoadNodesAction({ treeId: action.payload.treeId, id: null });
            }
        })));
        this.load$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_LOAD), mergeMap((/**
         * @param {?} action
         * @return {?}
         */
        (action) => this.loadNodes(action.payload.treeId, action.payload.id)
            .pipe(map((/**
         * @param {?} nodesData
         * @return {?}
         */
        (nodesData) => new TreeLoadNodesSuccessAction({
            treeId: action.payload.treeId,
            id: action.payload.id,
            nodes: nodesData
        }))), catchError((/**
         * @return {?}
         */
        () => of(new TreeLoadNodesErrorAction({
            treeId: action.payload.treeId,
            id: action.payload.id
        }))))))));
        this.delete$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_DELETE_NODE), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        (action) => this.deleteNode(action.payload.treeId, action.payload.node)
            .pipe(map((/**
         * @return {?}
         */
        () => new TreeDeleteNodeSuccessAction(Object.assign({}, action.payload)))), catchError((/**
         * @return {?}
         */
        () => of(new TreeDeleteNodeErrorAction(Object.assign({}, action.payload)))))))));
        this.save$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_SAVE_NODE), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        (action) => this.saveNode(action.payload.treeId, Object.assign({}, action.payload.node))
            .pipe(map((/**
         * @param {?} node
         * @return {?}
         */
        (node) => new TreeSaveNodeSuccessAction({
            treeId: action.payload.treeId,
            oldNode: action.payload.node,
            node
        }))), catchError((/**
         * @return {?}
         */
        () => of(new TreeSaveNodeErrorAction(Object.assign({}, action.payload)))))))));
        this.move$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_MOVE_NODE), filter((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            return action.payload.sourceOfDroppedData === DragAndDrop.DROP_DATA_TYPE;
        })), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            /** @type {?} */
            const source = (/** @type {?} */ (Object.assign({}, action.payload.oldNode)));
            /** @type {?} */
            const target = Boolean(action.payload.node) ? Object.assign({}, action.payload.node) : null;
            return this.moveNode(action.payload.treeId, source, target)
                .pipe(map((/**
             * @param {?} node
             * @return {?}
             */
            (node) => {
                return {
                    treeId: action.payload.treeId,
                    oldNode: action.payload.oldNode,
                    node: node
                };
            })), switchMap((/**
             * @param {?} data
             * @return {?}
             */
            (data) => {
                return this.store.select(treeConfigurationSelector(action.payload.treeId))
                    .pipe(take(1), map((/**
                 * @param {?} configuration
                 * @return {?}
                 */
                (configuration) => {
                    return {
                        configuration,
                        data
                    };
                })));
            })), catchError((/**
             * @return {?}
             */
            () => {
                /** @type {?} */
                const newAction = new TreeMoveNodeErrorAction({
                    treeId: action.payload.treeId,
                    source: action.payload.oldNode,
                    target: action.payload.node
                });
                return of(newAction);
            })));
        })), mergeMap((/**
         * @param {?} value
         * @return {?}
         */
        (value) => {
            /** @type {?} */
            const data = value.data;
            /** @type {?} */
            const actions = [
                new TreeMoveNodeSuccessAction({ treeId: data.treeId, source: data.oldNode, target: data.node }),
            ];
            if (!value.configuration.isFullyLoaded) {
                actions.push(new TreeLoadNodesAction({ treeId: data.treeId, id: data.node.parentId }));
            }
            return actions;
        })));
        this.expand$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_EXPAND_NODE), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        (action) => this.store
            .pipe(select(treeSelector(action.payload.treeId)), take(1), filter((/**
         * @param {?} treeState
         * @return {?}
         */
        (treeState) => !treeState.configuration.isFullyLoaded)), map((/**
         * @return {?}
         */
        () => {
            return new TreeLoadNodesAction({
                treeId: action.payload.treeId,
                id: action.payload.id
            });
        }))))));
        this.insert$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_INSERT_NODE), filter((/**
         * @param {?} action
         * @return {?}
         */
        (action) => !!action.payload.parentId)), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            return new TreeExpandNodeAction({ treeId: action.payload.treeId, id: action.payload.parentId });
        })));
        this.initPathForFullyLoadedTreeEffect$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_LOAD_PATH), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            return this.store.select(treeConfigurationSelector(action.payload.treeId))
                .pipe(take(1), map((/**
             * @param {?} configuration
             * @return {?}
             */
            (configuration) => {
                return { action, configuration };
            })));
        })), map((/**
         * @param {?} value
         * @return {?}
         */
        (value) => {
            const { action, configuration } = value;
            if (configuration.isFullyLoaded) {
                return action.payload.ids.map((/**
                 * @param {?} id
                 * @return {?}
                 */
                (id) => new TreeExpandNodeAction({ treeId: action.payload.treeId, id })));
            }
            else {
                /** @type {?} */
                const loadActions = action.payload.ids.map((/**
                 * @param {?} id
                 * @return {?}
                 */
                (id) => this.loadNodes(action.payload.treeId, id)));
                return combineLatest(loadActions)
                    .pipe(take(1), mergeMap((/**
                 * @param {?} data
                 * @return {?}
                 */
                (data) => {
                    /** @type {?} */
                    const loadSuccess = data.map((/**
                     * @param {?} nodes
                     * @param {?} index
                     * @return {?}
                     */
                    (nodes, index) => new TreeLoadNodesSuccessAction({
                        treeId: action.payload.treeId,
                        id: action.payload.ids[index],
                        nodes
                    })));
                    /** @type {?} */
                    const expandNodes = action.payload.ids.map((/**
                     * @param {?} id
                     * @return {?}
                     */
                    (id) => new TreeExpandNodeAction({
                        treeId: action.payload.treeId,
                        id
                    })));
                    return [...loadSuccess, ...expandNodes];
                })));
            }
        })), mergeMap((/**
         * @param {?} actions
         * @return {?}
         */
        (actions) => actions)));
    }
    /**
     * @protected
     * @param {?} treeId
     * @param {?} node
     * @return {?}
     */
    deleteNode(treeId, node) {
        /** @type {?} */
        const nodeService = this.nodeDispatcherService.get(treeId);
        return node.id ? nodeService.remove(node.id) : of(node);
    }
    /**
     * @protected
     * @param {?} treeId
     * @param {?} id
     * @return {?}
     */
    loadNodes(treeId, id) {
        /** @type {?} */
        const nodeService = this.nodeDispatcherService.get(treeId);
        return nodeService.load(id);
    }
    /**
     * @protected
     * @param {?} treeId
     * @param {?} node
     * @return {?}
     */
    saveNode(treeId, node) {
        /** @type {?} */
        const nodeService = this.nodeDispatcherService.get(treeId);
        if (node.id === NEW_NODE_ID) {
            return nodeService.add(node, node.parentId);
        }
        else {
            return nodeService.update(node);
        }
    }
    /**
     * @protected
     * @param {?} treeId
     * @param {?} source
     * @param {?} target
     * @return {?}
     */
    moveNode(treeId, source, target) {
        /** @type {?} */
        const nodeService = this.nodeDispatcherService.get(treeId);
        return nodeService.move(source, target);
    }
}
TreeEffectsService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
TreeEffectsService.ctorParameters = () => [
    { type: Actions },
    { type: NodeDispatcherService },
    { type: Store }
];
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "register$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "load$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "delete$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "save$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "move$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "expand$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "insert$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], TreeEffectsService.prototype, "initPathForFullyLoadedTreeEffect$", void 0);
if (false) {
    /** @type {?} */
    TreeEffectsService.prototype.register$;
    /** @type {?} */
    TreeEffectsService.prototype.load$;
    /** @type {?} */
    TreeEffectsService.prototype.delete$;
    /** @type {?} */
    TreeEffectsService.prototype.save$;
    /** @type {?} */
    TreeEffectsService.prototype.move$;
    /** @type {?} */
    TreeEffectsService.prototype.expand$;
    /** @type {?} */
    TreeEffectsService.prototype.insert$;
    /** @type {?} */
    TreeEffectsService.prototype.initPathForFullyLoadedTreeEffect$;
    /**
     * @type {?}
     * @private
     */
    TreeEffectsService.prototype.actions$;
    /**
     * @type {?}
     * @private
     */
    TreeEffectsService.prototype.nodeDispatcherService;
    /**
     * @type {?}
     * @private
     */
    TreeEffectsService.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TreeModelGeneratorService {
    /**
     * @param {?} nodeDispatcherService
     * @param {?} store
     */
    constructor(nodeDispatcherService, store) {
        this.nodeDispatcherService = nodeDispatcherService;
        this.store = store;
    }
    /**
     * @param {?} configuration
     * @param {?=} nodes
     * @return {?}
     */
    createTreeModel(configuration, nodes = null) {
        /** @type {?} */
        const treeId = configuration.treeId;
        /** @type {?} */
        const isFullyLoaded = Boolean(nodes);
        // register new tree in store
        this.store.dispatch(new TreeRegisterAction({
            treeId,
            silent: isFullyLoaded,
            nodes
        }));
        // init tree configuration
        this.store.dispatch(new TreeSetConfigurationAction({ treeId, configuration }));
        if (Boolean(nodes)) {
            this.nodeDispatcherService.get(treeId).setAllNodes(nodes);
            this.store.dispatch(new TreeMarkAsFullyLoadedAction({ treeId }));
        }
        /** @type {?} */
        const folders$ = this.store.select(treeSelector(configuration.treeId));
        return new TreeModel(this.store, folders$, configuration, isFullyLoaded);
    }
}
TreeModelGeneratorService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
TreeModelGeneratorService.ctorParameters = () => [
    { type: NodeDispatcherService },
    { type: Store }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    TreeModelGeneratorService.prototype.nodeDispatcherService;
    /**
     * @type {?}
     * @private
     */
    TreeModelGeneratorService.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ParentsListComponent {
    /**
     * @param {?} store
     */
    constructor(store) {
        this.store = store;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.parents$ = this.treeModel.getParentsList();
    }
    /**
     * @param {?} node
     * @param {?} isCurrentSelectedNode
     * @return {?}
     */
    selectNode(node, isCurrentSelectedNode) {
        if (!isCurrentSelectedNode) {
            this.store.dispatch(new TreeSelectNodeAction({
                treeId: this.treeModel.treeId,
                node,
            }));
        }
    }
}
ParentsListComponent.decorators = [
    { type: Component, args: [{
                selector: 'ri-tree-parents-list',
                template: "<ul class=\"ri-tree-parents-list\">\n  <li class=\"fa fa-home\" (click)=\"selectNode(null, false)\"></li>\n  <li *ngFor=\"let node of parents$ | async; last as isLast\" (click)=\"selectNode(node, isLast)\">{{node.name}}\n  </li>\n</ul>\n",
                styles: [".ri-tree-parents-list{list-style-type:none;margin:0;padding:0}.ri-tree-parents-list li{display:inline-block;cursor:pointer;color:#777}.ri-tree-parents-list li:after,.ri-tree-parents-list li:first-child,.ri-tree-parents-list li:last-child{color:#000}.ri-tree-parents-list li:not(:last-child):after{content:\"/\";display:inline-block;width:10px;text-align:center}"]
            }] }
];
/** @nocollapse */
ParentsListComponent.ctorParameters = () => [
    { type: Store }
];
ParentsListComponent.propDecorators = {
    treeModel: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    ParentsListComponent.prototype.treeModel;
    /** @type {?} */
    ParentsListComponent.prototype.parents$;
    /**
     * @type {?}
     * @protected
     */
    ParentsListComponent.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function INodeService() { }
if (false) {
    /** @type {?} */
    INodeService.prototype.treeId;
    /**
     * @param {?} nodeId
     * @return {?}
     */
    INodeService.prototype.load = function (nodeId) { };
    /**
     * @param {?} node
     * @param {?} parentNodeId
     * @return {?}
     */
    INodeService.prototype.add = function (node, parentNodeId) { };
    /**
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    INodeService.prototype.move = function (srcNode, targetNode) { };
    /**
     * @param {?} node
     * @return {?}
     */
    INodeService.prototype.update = function (node) { };
    /**
     * @param {?} nodeId
     * @return {?}
     */
    INodeService.prototype.remove = function (nodeId) { };
    /**
     * @param {?} nodes
     * @return {?}
     */
    INodeService.prototype.setAllNodes = function (nodes) { };
}
/** @type {?} */
const NODE_SERVICE = new InjectionToken('NODE_SERVICE');
class NodeService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
        this.apiConfig = {
            addUrl: '/api/nodes',
            getUrl: '/api/nodes',
            moveUrl: '/api/nodes/move',
            updateUrl: '/api/nodes',
            removeUrl: '/api/nodes',
        };
    }
    /**
     * @return {?}
     */
    get treeId() {
        return 'tree';
    }
    /**
     * @param {?} nodes
     * @return {?}
     */
    setAllNodes(nodes) {
    }
    /**
     * @param {?=} nodeId
     * @return {?}
     */
    load(nodeId = '') {
        /** @type {?} */
        const params = new HttpParams().set('nodeId', nodeId);
        return this.http.get(this.getPath('GET', nodeId), { params });
    }
    /**
     * @param {?} node
     * @param {?=} parentNodeId
     * @return {?}
     */
    add(node, parentNodeId = null) {
        return this.http.post(this.getPath('CREATE', parentNodeId), {
            node: node,
            parentNodeId: parentNodeId
        });
    }
    /**
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    move(srcNode, targetNode) {
        /** @type {?} */
        const srcId = srcNode.id;
        /** @type {?} */
        const targetId = targetNode ? targetNode.id : null;
        return this.http.put(this.getPath('MOVE', srcId, targetId), { source: srcId, target: targetId });
    }
    /**
     * @param {?} node
     * @return {?}
     */
    update(node) {
        return this.http.put(this.getPath('UPDATE', node.id), node);
    }
    /**
     * @param {?} nodeId
     * @return {?}
     */
    remove(nodeId) {
        /** @type {?} */
        const params = new HttpParams().set('nodeId', nodeId);
        return this.http.delete(this.getPath('REMOVE', nodeId), { params });
    }
    /**
     * @protected
     * @param {?} type
     * @param {?} nodeId
     * @param {?=} destNodeId
     * @return {?}
     */
    getPath(type, nodeId, destNodeId = null) {
        if (!this.apiConfig) {
            throw new Error('No API configuration for Tree');
        }
        /** @type {?} */
        const urlMap = {
            'GET': this.apiConfig.getUrl,
            'CREATE': this.apiConfig.addUrl,
            'REMOVE': this.apiConfig.removeUrl,
            'UPDATE': this.apiConfig.updateUrl,
            'MOVE': this.apiConfig.moveUrl
        };
        /** @type {?} */
        let path = this.replaceNodeId(urlMap[type], nodeId);
        if (destNodeId) {
            path = this.replaceDestNodeId(path, destNodeId);
        }
        return path;
    }
    /**
     * @protected
     * @param {?} url
     * @param {?} nodeId
     * @return {?}
     */
    replaceNodeId(url, nodeId) {
        return url.replace('{nodeId}', nodeId);
    }
    /**
     * @protected
     * @param {?} url
     * @param {?} nodeId
     * @return {?}
     */
    replaceDestNodeId(url, nodeId) {
        return url.replace('{destNodeId}', nodeId);
    }
}
NodeService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NodeService.ctorParameters = () => [
    { type: HttpClient }
];
if (false) {
    /**
     * @type {?}
     * @protected
     */
    NodeService.prototype.apiConfig;
    /**
     * @type {?}
     * @protected
     */
    NodeService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TreeInitializerService {
    /**
     * @param {?} treeModelGeneratorService
     * @param {?} nodeDispatcherService
     */
    constructor(treeModelGeneratorService, nodeDispatcherService) {
        this.treeModelGeneratorService = treeModelGeneratorService;
        this.nodeDispatcherService = nodeDispatcherService;
    }
    /**
     * @param {?} treeConfiguration
     * @param {?} treeApi
     * @param {?=} loadedNodes
     * @return {?}
     */
    init(treeConfiguration, treeApi, loadedNodes) {
        this.nodeDispatcherService.registerService(treeConfiguration.treeId, treeApi);
        return this.treeModelGeneratorService.createTreeModel(treeConfiguration, loadedNodes);
    }
}
TreeInitializerService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
TreeInitializerService.ctorParameters = () => [
    { type: TreeModelGeneratorService },
    { type: NodeDispatcherService }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    TreeInitializerService.prototype.treeModelGeneratorService;
    /**
     * @type {?}
     * @private
     */
    TreeInitializerService.prototype.nodeDispatcherService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const NODE_DISPATCHER_TOKEN = new InjectionToken('NodeDispatcherService');
class TreeModule {
    constructor() {
    }
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: TreeModule,
            providers: [
                DragAndDrop,
                NodeDispatcherService,
                TreeEffectsService,
                TreeInitializerService,
                TreeModelGeneratorService,
            ]
        };
    }
    /**
     * @return {?}
     */
    static forFeature() {
        return {
            ngModule: TreeModule,
            providers: [],
        };
    }
}
TreeModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    ContextMenuModule,
                    DndModule,
                    EffectsModule.forFeature([TreeEffectsService]),
                    HttpClientModule,
                    FormsModule,
                    ReactiveFormsModule,
                    StoreModule.forFeature('trees', treeReducer),
                ],
                declarations: [
                    TreeComponent,
                    ItemComponent,
                    DraggableDirective,
                    DroppableDirective,
                    DropzoneComponent,
                    ParentsListComponent,
                ],
                exports: [
                    TreeComponent,
                    ItemComponent,
                    DraggableDirective,
                    DroppableDirective,
                    DropzoneComponent,
                    DraggableComponent,
                    ParentsListComponent,
                    StoreModule,
                    EffectsModule,
                ],
                providers: [
                    { provide: NODE_SERVICE, useClass: NodeService, multi: true }
                ],
                schemas: [CUSTOM_ELEMENTS_SCHEMA]
            },] }
];
/** @nocollapse */
TreeModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IAppConfig() { }
if (false) {
    /** @type {?} */
    IAppConfig.prototype.addUrl;
    /** @type {?} */
    IAppConfig.prototype.getUrl;
    /** @type {?} */
    IAppConfig.prototype.updateUrl;
    /** @type {?} */
    IAppConfig.prototype.removeUrl;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IConfiguration() { }
if (false) {
    /** @type {?|undefined} */
    IConfiguration.prototype.disableContextMenu;
    /** @type {?|undefined} */
    IConfiguration.prototype.disableMoveNodes;
    /** @type {?|undefined} */
    IConfiguration.prototype.showAddButton;
    /** @type {?|undefined} */
    IConfiguration.prototype.treeId;
    /** @type {?|undefined} */
    IConfiguration.prototype.dragZone;
    /** @type {?|undefined} */
    IConfiguration.prototype.dropZone;
    /** @type {?|undefined} */
    IConfiguration.prototype.isAnimation;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IContextMenu() { }
if (false) {
    /** @type {?} */
    IContextMenu.prototype.name;
    /** @type {?} */
    IContextMenu.prototype.text;
    /** @type {?|undefined} */
    IContextMenu.prototype.iconCls;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IOuterNode() { }
if (false) {
    /** @type {?} */
    IOuterNode.prototype.id;
    /** @type {?|undefined} */
    IOuterNode.prototype.treeId;
    /** @type {?} */
    IOuterNode.prototype.name;
    /** @type {?|undefined} */
    IOuterNode.prototype.parentId;
    /** @type {?|undefined} */
    IOuterNode.prototype.children;
    /** @type {?|undefined} */
    IOuterNode.prototype.parents;
    /** @type {?} */
    IOuterNode.prototype.isExpanded;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ITreeTranslations() { }
if (false) {
    /** @type {?} */
    ITreeTranslations.prototype.RI_TREE_LBL_ADD_NODE;
    /** @type {?} */
    ITreeTranslations.prototype.RI_TREE_LBL_EDIT_NODE;
    /** @type {?} */
    ITreeTranslations.prototype.RI_TREE_LBL_REMOVE_NODE;
    /** @type {?} */
    ITreeTranslations.prototype.RI_TREE_LBL_DROP_ZONE;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IApiConfig() { }
if (false) {
    /** @type {?} */
    IApiConfig.prototype.addUrl;
    /** @type {?} */
    IApiConfig.prototype.getUrl;
    /** @type {?} */
    IApiConfig.prototype.moveUrl;
    /** @type {?} */
    IApiConfig.prototype.updateUrl;
    /** @type {?} */
    IApiConfig.prototype.removeUrl;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ITreeNodes() { }
/**
 * @record
 */
function ITreeConfiguration() { }
if (false) {
    /** @type {?} */
    ITreeConfiguration.prototype.isFullyLoaded;
}
/**
 * @record
 */
function ITreeData() { }
if (false) {
    /** @type {?} */
    ITreeData.prototype.nodes;
    /** @type {?} */
    ITreeData.prototype.configuration;
}
/**
 * @record
 */
function ITreeState() { }
/**
 * @record
 */
function ITreeActionPayload() { }
if (false) {
    /** @type {?} */
    ITreeActionPayload.prototype.treeId;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.url;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.id;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.node;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.nodes;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.oldNode;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.source;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.target;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.sourceOfDroppedData;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.ids;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.silent;
    /** @type {?|undefined} */
    ITreeActionPayload.prototype.hasLoadedNodes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DragAndDrop, DraggableDirective, DroppableDirective, DropzoneComponent, ItemComponent, NEW_NODE_ID, NODE_DISPATCHER_TOKEN, NODE_SERVICE, NodeDispatcherService, NodeService, ParentsListComponent, TREE_TRANSLATION_TOKEN, TreeActionTypes, TreeCollapseNodeAction, TreeComponent, TreeDeleteNodeAction, TreeDeleteNodeErrorAction, TreeDeleteNodeSuccessAction, TreeEditNodeStartAction, TreeEffectsService, TreeExpandNodeAction, TreeInitializerService, TreeInsertNodeAction, TreeLoadNodesAction, TreeLoadNodesErrorAction, TreeLoadNodesSuccessAction, TreeLoadPathAction, TreeMarkAsFullyLoadedAction, TreeModel, TreeModelGeneratorService, TreeModule, TreeMoveNodeAction, TreeMoveNodeErrorAction, TreeMoveNodeSuccessAction, TreeRegisterAction, TreeSaveNodeAction, TreeSaveNodeErrorAction, TreeSaveNodeSuccessAction, TreeSelectNodeAction, TreeSetAllNodesAction, TreeSetConfigurationAction, emptyTreeData, expand, expandedNodesSelector, previouslySelectedNodeSelector, selectedNodeSelector, treeConfigurationSelector, treeReducer, treeSelector, treeStateSelector };
//# sourceMappingURL=rign-angular2-tree.js.map
